/**
 * pony.find clients backend API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.1.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from './configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import type { RequestArgs } from './base';
import { BaseAPI } from './base';
/**
 *
 * @export
 * @interface Fandom
 */
export interface Fandom {
    /**
     *
     * @type {string}
     * @memberof Fandom
     */
    'id'?: string;
    /**
     *
     * @type {string}
     * @memberof Fandom
     */
    'name'?: string;
    /**
     *
     * @type {string}
     * @memberof Fandom
     */
    'color'?: string;
    /**
     *
     * @type {string}
     * @memberof Fandom
     */
    'emoji'?: string;
    /**
     *
     * @type {Image}
     * @memberof Fandom
     */
    'icon'?: Image;
}
/**
 *
 * @export
 * @interface HistoryItem
 */
export interface HistoryItem {
    /**
     *
     * @type {string}
     * @memberof HistoryItem
     */
    'id'?: string;
    /**
     *
     * @type {string}
     * @memberof HistoryItem
     */
    'match_id'?: string;
    /**
     *
     * @type {Profile}
     * @memberof HistoryItem
     */
    'profile'?: Profile;
    /**
     *
     * @type {string}
     * @memberof HistoryItem
     */
    'action_type'?: HistoryItemActionTypeEnum;
}
export declare const HistoryItemActionTypeEnum: {
    readonly Like: "like";
    readonly Dislike: "dislike";
};
export type HistoryItemActionTypeEnum = typeof HistoryItemActionTypeEnum[keyof typeof HistoryItemActionTypeEnum];
/**
 *
 * @export
 * @interface Image
 */
export interface Image {
    /**
     *
     * @type {string}
     * @memberof Image
     */
    'url'?: string;
}
/**
 *
 * @export
 * @interface ModelError
 */
export interface ModelError {
    /**
     *
     * @type {string}
     * @memberof ModelError
     */
    'type'?: string;
    /**
     *
     * @type {string}
     * @memberof ModelError
     */
    'description'?: string;
    /**
     *
     * @type {object}
     * @memberof ModelError
     */
    'details'?: object;
}
/**
 *
 * @export
 * @interface Profile
 */
export interface Profile {
    /**
     * only for moderators usage
     * @type {string}
     * @memberof Profile
     */
    'user_id'?: string;
    /**
     * profile id shows only for owner or moderator
     * @type {string}
     * @memberof Profile
     */
    'id'?: string;
    /**
     * for matches routes usage
     * @type {string}
     * @memberof Profile
     */
    'match_id'?: string;
    /**
     *
     * @type {string}
     * @memberof Profile
     */
    'name'?: string;
    /**
     *
     * @type {string}
     * @memberof Profile
     */
    'birthdate'?: string;
    /**
     *
     * @type {Array<Fandom>}
     * @memberof Profile
     */
    'fandoms'?: Array<Fandom>;
    /**
     *
     * @type {Array<Image>}
     * @memberof Profile
     */
    'image'?: Array<Image>;
}
/**
 *
 * @export
 * @interface ProfilesGet200Response
 */
export interface ProfilesGet200Response {
    /**
     *
     * @type {Array<Profile>}
     * @memberof ProfilesGet200Response
     */
    'items': Array<Profile>;
    /**
     *
     * @type {number}
     * @memberof ProfilesGet200Response
     */
    'count': number;
    /**
     *
     * @type {number}
     * @memberof ProfilesGet200Response
     */
    'total': number;
}
/**
 *
 * @export
 * @interface ProfilesIdMatchesHistoryGet200Response
 */
export interface ProfilesIdMatchesHistoryGet200Response {
    /**
     *
     * @type {Array<HistoryItem>}
     * @memberof ProfilesIdMatchesHistoryGet200Response
     */
    'items': Array<HistoryItem>;
    /**
     *
     * @type {number}
     * @memberof ProfilesIdMatchesHistoryGet200Response
     */
    'count': number;
    /**
     *
     * @type {number}
     * @memberof ProfilesIdMatchesHistoryGet200Response
     */
    'total': number;
}
/**
 *
 * @export
 * @interface ProfilesMatchesIdReportPostRequest
 */
export interface ProfilesMatchesIdReportPostRequest {
    /**
     *
     * @type {string}
     * @memberof ProfilesMatchesIdReportPostRequest
     */
    'reason': ProfilesMatchesIdReportPostRequestReasonEnum;
    /**
     *
     * @type {string}
     * @memberof ProfilesMatchesIdReportPostRequest
     */
    'description'?: string;
}
export declare const ProfilesMatchesIdReportPostRequestReasonEnum: {
    readonly Spam: "spam";
    readonly Advertising: "advertising";
    readonly Porn: "porn";
    readonly Custom: "custom";
};
export type ProfilesMatchesIdReportPostRequestReasonEnum = typeof ProfilesMatchesIdReportPostRequestReasonEnum[keyof typeof ProfilesMatchesIdReportPostRequestReasonEnum];
/**
 * DefaultApi - axios parameter creator
 * @export
 */
export declare const DefaultApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get current user profiles
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesGet: (limit: number, offset: number, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Archive profile
     * @param {string} id Profile ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdDelete: (id: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get profile by ID
     * @param {string} id Profile ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdGet: (id: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get dates for matched profile
     * @param {string} id Profile ID
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdMatchesDatesGet: (id: string, limit: number, offset: number, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get a list of matched profiles for a particular profile
     * @param {string} id Profile ID
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdMatchesGet: (id: string, limit: number, offset: number, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get a history of matches for a specific profile
     * @param {string} id Profile ID
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdMatchesHistoryGet: (id: string, limit: number, offset: number, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update profile
     * @param {string} id Profile ID
     * @param {Profile} profile
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdPatch: (id: string, profile: Profile, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Dislike the profile match
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdDislikePost: (id: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get a specific profile match by ID
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdGet: (id: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Like the profile match
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdLikePost: (id: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Report the profile match
     * @param {string} id Match ID
     * @param {ProfilesMatchesIdReportPostRequest} profilesMatchesIdReportPostRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdReportPost: (id: string, profilesMatchesIdReportPostRequest: ProfilesMatchesIdReportPostRequest, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Skip the profile match
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdSkipPost: (id: string, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create new profile
     * @param {Profile} profile
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesPost: (profile: Profile, options?: RawAxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * DefaultApi - functional programming interface
 * @export
 */
export declare const DefaultApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get current user profiles
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesGet(limit: number, offset: number, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProfilesGet200Response>>;
    /**
     *
     * @summary Archive profile
     * @param {string} id Profile ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdDelete(id: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     *
     * @summary Get profile by ID
     * @param {string} id Profile ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdGet(id: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Profile>>;
    /**
     *
     * @summary Get dates for matched profile
     * @param {string} id Profile ID
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdMatchesDatesGet(id: string, limit: number, offset: number, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProfilesGet200Response>>;
    /**
     *
     * @summary Get a list of matched profiles for a particular profile
     * @param {string} id Profile ID
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdMatchesGet(id: string, limit: number, offset: number, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProfilesGet200Response>>;
    /**
     *
     * @summary Get a history of matches for a specific profile
     * @param {string} id Profile ID
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdMatchesHistoryGet(id: string, limit: number, offset: number, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ProfilesIdMatchesHistoryGet200Response>>;
    /**
     *
     * @summary Update profile
     * @param {string} id Profile ID
     * @param {Profile} profile
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdPatch(id: string, profile: Profile, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Profile>>;
    /**
     *
     * @summary Dislike the profile match
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdDislikePost(id: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     *
     * @summary Get a specific profile match by ID
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdGet(id: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Profile>>;
    /**
     *
     * @summary Like the profile match
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdLikePost(id: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     *
     * @summary Report the profile match
     * @param {string} id Match ID
     * @param {ProfilesMatchesIdReportPostRequest} profilesMatchesIdReportPostRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdReportPost(id: string, profilesMatchesIdReportPostRequest: ProfilesMatchesIdReportPostRequest, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     *
     * @summary Skip the profile match
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdSkipPost(id: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>>;
    /**
     *
     * @summary Create new profile
     * @param {Profile} profile
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesPost(profile: Profile, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Profile>>;
};
/**
 * DefaultApi - factory interface
 * @export
 */
export declare const DefaultApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get current user profiles
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesGet(limit: number, offset: number, options?: RawAxiosRequestConfig): AxiosPromise<ProfilesGet200Response>;
    /**
     *
     * @summary Archive profile
     * @param {string} id Profile ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdDelete(id: string, options?: RawAxiosRequestConfig): AxiosPromise<void>;
    /**
     *
     * @summary Get profile by ID
     * @param {string} id Profile ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdGet(id: string, options?: RawAxiosRequestConfig): AxiosPromise<Profile>;
    /**
     *
     * @summary Get dates for matched profile
     * @param {string} id Profile ID
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdMatchesDatesGet(id: string, limit: number, offset: number, options?: RawAxiosRequestConfig): AxiosPromise<ProfilesGet200Response>;
    /**
     *
     * @summary Get a list of matched profiles for a particular profile
     * @param {string} id Profile ID
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdMatchesGet(id: string, limit: number, offset: number, options?: RawAxiosRequestConfig): AxiosPromise<ProfilesGet200Response>;
    /**
     *
     * @summary Get a history of matches for a specific profile
     * @param {string} id Profile ID
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdMatchesHistoryGet(id: string, limit: number, offset: number, options?: RawAxiosRequestConfig): AxiosPromise<ProfilesIdMatchesHistoryGet200Response>;
    /**
     *
     * @summary Update profile
     * @param {string} id Profile ID
     * @param {Profile} profile
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesIdPatch(id: string, profile: Profile, options?: RawAxiosRequestConfig): AxiosPromise<Profile>;
    /**
     *
     * @summary Dislike the profile match
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdDislikePost(id: string, options?: RawAxiosRequestConfig): AxiosPromise<void>;
    /**
     *
     * @summary Get a specific profile match by ID
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdGet(id: string, options?: RawAxiosRequestConfig): AxiosPromise<Profile>;
    /**
     *
     * @summary Like the profile match
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdLikePost(id: string, options?: RawAxiosRequestConfig): AxiosPromise<void>;
    /**
     *
     * @summary Report the profile match
     * @param {string} id Match ID
     * @param {ProfilesMatchesIdReportPostRequest} profilesMatchesIdReportPostRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdReportPost(id: string, profilesMatchesIdReportPostRequest: ProfilesMatchesIdReportPostRequest, options?: RawAxiosRequestConfig): AxiosPromise<void>;
    /**
     *
     * @summary Skip the profile match
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesMatchesIdSkipPost(id: string, options?: RawAxiosRequestConfig): AxiosPromise<void>;
    /**
     *
     * @summary Create new profile
     * @param {Profile} profile
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    profilesPost(profile: Profile, options?: RawAxiosRequestConfig): AxiosPromise<Profile>;
};
/**
 * DefaultApi - object-oriented interface
 * @export
 * @class DefaultApi
 * @extends {BaseAPI}
 */
export declare class DefaultApi extends BaseAPI {
    /**
     *
     * @summary Get current user profiles
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    profilesGet(limit: number, offset: number, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<ProfilesGet200Response, any>>;
    /**
     *
     * @summary Archive profile
     * @param {string} id Profile ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    profilesIdDelete(id: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<void, any>>;
    /**
     *
     * @summary Get profile by ID
     * @param {string} id Profile ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    profilesIdGet(id: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<Profile, any>>;
    /**
     *
     * @summary Get dates for matched profile
     * @param {string} id Profile ID
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    profilesIdMatchesDatesGet(id: string, limit: number, offset: number, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<ProfilesGet200Response, any>>;
    /**
     *
     * @summary Get a list of matched profiles for a particular profile
     * @param {string} id Profile ID
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    profilesIdMatchesGet(id: string, limit: number, offset: number, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<ProfilesGet200Response, any>>;
    /**
     *
     * @summary Get a history of matches for a specific profile
     * @param {string} id Profile ID
     * @param {number} limit
     * @param {number} offset
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    profilesIdMatchesHistoryGet(id: string, limit: number, offset: number, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<ProfilesIdMatchesHistoryGet200Response, any>>;
    /**
     *
     * @summary Update profile
     * @param {string} id Profile ID
     * @param {Profile} profile
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    profilesIdPatch(id: string, profile: Profile, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<Profile, any>>;
    /**
     *
     * @summary Dislike the profile match
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    profilesMatchesIdDislikePost(id: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<void, any>>;
    /**
     *
     * @summary Get a specific profile match by ID
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    profilesMatchesIdGet(id: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<Profile, any>>;
    /**
     *
     * @summary Like the profile match
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    profilesMatchesIdLikePost(id: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<void, any>>;
    /**
     *
     * @summary Report the profile match
     * @param {string} id Match ID
     * @param {ProfilesMatchesIdReportPostRequest} profilesMatchesIdReportPostRequest
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    profilesMatchesIdReportPost(id: string, profilesMatchesIdReportPostRequest: ProfilesMatchesIdReportPostRequest, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<void, any>>;
    /**
     *
     * @summary Skip the profile match
     * @param {string} id Match ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    profilesMatchesIdSkipPost(id: string, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<void, any>>;
    /**
     *
     * @summary Create new profile
     * @param {Profile} profile
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    profilesPost(profile: Profile, options?: RawAxiosRequestConfig): Promise<import("axios").AxiosResponse<Profile, any>>;
}
